<?php

/* $Id: OaiTaskList.class.php,v 1.6 2007/05/30 09:59:32 sondberg Exp $
 * ------------------------------------------------------------------
 * This class implements methods for looking up tasks in the task dir
 */

require_once('OaiTask.class.php');

class OaiTaskList
{
    private $taskDir;

    public function __construct ($task_dir = '')
    {
        if ( strlen($task_dir) )
            $this->taskDir = $task_dir;
        else
            $this->taskDir = dirname(__FILE__) . '/../../../var/oai';
    }

    private function getTaskByFile ($file)
    {
        return new OaiTask(array('task_file' => $this->taskDir . '/' . $file) );
    }


    public function getTaskById ($id)
    {
        return $this->getTaskByFile($id);
    }


    public function createNew ($data)
    {
        return new OaiTask( array('task_dir'        => $this->taskDir,
                                  'data'            => $data) );
    }


    public function getTasks ($date = '')
    { 
        $dh = opendir($this->taskDir);
        $ret = array();

        while ( false !== ($file = readdir($dh)) ) {
            if ( preg_match('/\.xml$/', $file) )
                $ret[$file] = $this->getTaskByFile($file);
        }

        return $ret;
    }


    public function getTasksXML ($date = '')
    {
        $tasks = $this->getTasks($date);
        $doc = new DOMDocument();
        $root = $doc->createElement('tasklist');
        $doc->appendChild($root);

        foreach ($tasks as $f => $t) {
            $doc_elem = $t->documentElement;
            $task = $doc->createElement('task');
            $task->setAttribute('id', $f);
            $t_root = $t->documentElement;

            foreach ($t_root->childNodes as $kid) {
                if ( $kid->nodeType == XML_ELEMENT_NODE ) {
                    $task->setAttribute($kid->nodeName, $kid->textContent);
                }
            }

            $root->appendChild($task);
        }

        return $doc;
    }
}
