<?php


require_once('includes.phpi');
require_once 'propel/Propel.php';
require_once 'UserData.class.php';

//define ("__DEBUG__", true );

Propel::init(OW_PROPEL_CONF);
session_start();

header('Content-type: text/xml');

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

$response = new DOMDocument();
$response->appendChild( new DOMElement('userdataws') );
$attrs = null;

if ( !( $userId = check_user_id() ) )
    print_error($response, 'You are not logged in.');

if ( isset( $_REQUEST['attrs'] ) )
    $attrs = explode( ',', $_REQUEST['attrs'] );

switch ($_REQUEST['command']) {
    
    case 'save' : 

        save_data($userId, 'php://input', $response);
        break;

    case 'fetch' :
        
        fetch_data($userId, $attrs, $response);
        break;

    default :
        
        print_error($response, 'Command unknown.');

}

$response->documentElement->appendChild( new DOMElement('status', 'OK') );
echo $response->saveXML();

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

function check_user_id ()
{
    return isset( $_SESSION['auth']['policy']['userid']['value'] )
        ? $_SESSION['auth']['policy']['userid']['value']
        : false;
}

function save_data ($userId, $path, $doc)
{
    try {
        $udDoc = new DOMDocument();
        $udDoc->load($path);

        $ud = new UserData($userId);
        $ud->loadXML($udDoc);
    } catch (Exception $e) {
        print_error($doc, $e->getMessage() );
    }
}

function fetch_data ($userId, $attrs, $doc)
{
    try {
        $ud = new UserData($userId, $attrs );
    } catch (Exception $e) {
        print_error($doc, $e->getMessage() );
    }
    
    $doc->documentElement->appendChild ( $doc->importNode( $ud->documentElement, true ) );
}

function print_error ($doc, $errMsg)
{
    $doc->documentElement->appendChild ( new DOMElement('status', 'failed') );
    $doc->documentElement->appendChild ( new DOMElement('message', $errMsg) );

    if (__DEBUG__) {
        $doc->documentElement->appendChild ( new DOMElement('get_params', join(' ', $_REQUEST ) ) );
        $doc->documentElement->appendChild ( new DOMElement('post_input', file_get_contents('php://input') ) );
    }
    
    echo $doc->saveXML();
    exit;
}
